
proc getallgroups { {force 0} } {
	global news groups sgroups


	if { $force == 1 || ![file exists $news(home)/groups.dat] } {
		set sock [connectit]
		if { $sock != "" && [tk_dialog .nd "$news(tclnews) $news(version)" "Downloading all news groups will take some time.\nWould you like to download them now?" question 0 OK CANCEL] == 0 } {
			socksend $sock "list active"
			set res ""
			while { $res == "" } {
				set res [readsock $sock]
				set val [string range $res 0 2]
			}
		
		   if { $val != 215 } {
			tk_dialog .nd "$news(tclnews) $news(version)" \
				"Can't get groups ($res)" \
				error 0 OK CANCEL] == 0 
			return
		   }

		set news(.news,message) "Reading all active news groups From server"
			set fd [open $news(home)/groups.dat w] 
			set news(.news,l1) 0
			set count 0
			set news(showall) 1
			.news.main configure -cursor watch
			while { $res != "." } {
				set res [readsock $sock] 
			
				# This will certainly couse problems.  
				# Might be better to close and reopen the connections.
				if { $news(.news,stop) == 1 } { 
					close $fd
					set news(grp_date) [clock format [clock seconds] -format "%y%m%d %H%M%S" -gmt 1] 
					set news(.news,message) "Operation Terminated"
					.news.main configure -cursor ""
					return 
				} 
				
				if { $res != "" && $res != "." } {
					set lst [split $res]
					set g [lindex $lst 0 ]
					set y [lindex $lst 3 ]
					set groups($g) $y
					inslst .news $g 0
					puts $fd "$g $y"
					incr count
				}
				if { $count >= 30 } {
					incr news(.news,l1)  $count
					set count 0
					update
				}
			}
			close $fd
			set news(grp_date) [clock format [clock seconds] -gmt 1] ; # tclsock.so
			set news(.news,message) "Operation Complete"
			.news.main configure -cursor ""
			disconnect $sock
			return
		}
	} else {
		set news(.news,message) "Reading all active news groups From $news(home)/groups.dat"
		set fd [open $news(home)/groups.dat r]
		set news(.news,l1) 0
		set count 0
		set news(showall) 1
		while { [gets $fd line] > 0 } {
			set l [split $line]
			set g [lindex $l 0]
			set y [lindex $l 1]
			set groups($g) $y
			inslst .news $g 0
			incr count
			if { $count >= 30 } {
				incr news(.news,l1) $count
				set count 0
				update
			}
		}
		close $fd
		incr news(.news,l1) $count
		set news(.news,message) "Operation Complete"
	}
}

